package com.yemeishu.myfirstnativestore;


import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

import com.yemeishu.myfirstnativestore.store.Store;
import com.yemeishu.myfirstnativestore.store.StoreType;

public class StoreActivity extends Activity {

	private EditText mUIKeyEdit, mUIValueEdit;
	private Spinner mUITypeSpinner;
	private Button mUIGetButton, mUISetButton;
	private Store mStore;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		
		mUIKeyEdit = (EditText) findViewById(R.id.uiKeyEdit);
		mUIValueEdit = (EditText) findViewById(R.id.uiValueEdit);
		mUITypeSpinner = (Spinner) findViewById(R.id.uiTypeSpinner);
		
		mUIGetButton = (Button) findViewById(R.id.getValue);
		mUISetButton = (Button) findViewById(R.id.setValue);
		
		mStore = new Store();
		
		mUIGetButton.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Զɵķ
				onGetValue();
			}
		});
		
		mUISetButton.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Զɵķ
				onSetValue();
			}
		});
	}
	
	private void onGetValue() {
		String lKey = mUIKeyEdit.getText().toString();
		String lType1 = (String) mUITypeSpinner.getSelectedItem();
		
		StoreType lType = StoreType.Integer;
		if("String".equals(lType1))
			lType = StoreType.String;
		
		System.out.println(lType.toString());
		switch (lType) {
		case Integer:
			mUIValueEdit.setText(Integer.toString(mStore.getInteger(lKey)));
			break;
		case String:
			mUIValueEdit.setText(mStore.getString(lKey));
			break;
		}
	}
	
	private void onSetValue() {
		String lKey = mUIKeyEdit.getText().toString();
		String lValue = mUIValueEdit.getText().toString();
		
		System.out.println(lKey.toString() + " " + lValue.toString());
		Log.i("1", lKey.toString() + " " + lValue.toString());
		
		
		System.out.println(mUITypeSpinner.getSelectedItem().toString());
		
		String lType1 = (String) mUITypeSpinner.getSelectedItem();
		
		StoreType lType = StoreType.Integer;
		if("String".equals(lType1))
			lType = StoreType.String;
		
		System.out.println(mUITypeSpinner.getSelectedItem().toString());
		try {
			switch (lType) {
			case Integer:
				mStore.setInteger(lKey, Integer.parseInt(lValue));
				break;
			case String:
				mStore.setString(lKey, lValue);
				break;
			}
		} catch (NumberFormatException eNumberFormatException) {
			displayError("Incorrect value.");
		}
	}
	private void displayError(String pError) {
		Toast.makeText(getApplicationContext(), pError, Toast.LENGTH_LONG)
		.show();
			}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

}
